    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * StandardXYItemLabelGenerator.java
    029     * ---------------------------------
    030     * (C) Copyright 2001-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 13-Dec-2001 : Version 1 (DG);
    038     * 16-Jan-2002 : Completed Javadocs (DG);
    039     * 02-Apr-2002 : Modified to handle null y-values (DG);
    040     * 09-Apr-2002 : Added formatting objects for the x and y values (DG);
    041     * 30-May-2002 : Added series name to standard tool tip (DG);
    042     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    043     * 23-Mar-2003 : Implemented Serializable (DG);
    044     * 13-Aug-2003 : Implemented Cloneable (DG);
    045     * 17-Nov-2003 : Implemented PublicCloneable (DG);
    046     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator and
    047     *               StandardXYToolTipGenerator -->
    048     *               StandardXYItemLabelGenerator (DG);
    049     * 26-Feb-2004 : Modified to use MessageFormat (DG);
    050     * 27-Feb-2004 : Added abstract superclass (DG);
    051     * 11-May-2004 : Split into StandardXYToolTipGenerator and
    052     *               StandardXYLabelGenerator (DG);
    053     * 20-Apr-2005 : Renamed StandardXYLabelGenerator
    054     *               --> StandardXYItemLabelGenerator (DG);
    055     * ------------- JFREECHART 1.0.x ---------------------------------------------
    056     * 25-Jan-2007 : Added new constructor - see bug 1624067 (DG);
    057     *
    058     */
    059
    060    package org.jfree.chart.labels;
    061
    062    import java.io.Serializable;
    063    import java.text.DateFormat;
    064    import java.text.NumberFormat;
    065
    066    import org.jfree.data.xy.XYDataset;
    067    import org.jfree.util.PublicCloneable;
    068
    069    /**
    070     * A standard item label generator for plots that use data from an
    071     * {@link org.jfree.data.xy.XYDataset}.
    072     */
    073    public class StandardXYItemLabelGenerator extends AbstractXYItemLabelGenerator
    074            implements XYItemLabelGenerator, Cloneable, PublicCloneable,
    075                Serializable {
    076
    077        /** For serialization. */
    078        private static final long serialVersionUID = 7807668053171837925L;
    079
    080        /** The default item label format. */
    081        public static final String DEFAULT_ITEM_LABEL_FORMAT = "{2}";
    082
    083        /**
    084         * Creates an item label generator using default number formatters.
    085         */
    086        public StandardXYItemLabelGenerator() {
    087            this(DEFAULT_ITEM_LABEL_FORMAT, NumberFormat.getNumberInstance(),
    088                    NumberFormat.getNumberInstance());
    089        }
    090
    091
    092        /**
    093         * Creates an item label generator using the specified number formatters.
    094         *
    095         * @param formatString  the item label format string (<code>null</code> not
    096         *                      permitted).
    097         * @param xFormat  the format object for the x values (<code>null</code>
    098         *                 not permitted).
    099         * @param yFormat  the format object for the y values (<code>null</code>
    100         *                 not permitted).
    101         */
    102        public StandardXYItemLabelGenerator(String formatString,
    103                NumberFormat xFormat, NumberFormat yFormat) {
    104
    105            super(formatString, xFormat, yFormat);
    106        }
    107
    108        /**
    109         * Creates an item label generator using the specified formatters.
    110         *
    111         * @param formatString  the item label format string (<code>null</code>
    112         *                      not permitted).
    113         * @param xFormat  the format object for the x values (<code>null</code>
    114         *                 not permitted).
    115         * @param yFormat  the format object for the y values (<code>null</code>
    116         *                 not permitted).
    117         */
    118        public StandardXYItemLabelGenerator(String formatString,
    119                DateFormat xFormat, NumberFormat yFormat) {
    120
    121            super(formatString, xFormat, yFormat);
    122        }
    123
    124        /**
    125         * Creates an item label generator using the specified formatters (a
    126         * number formatter for the x-values and a date formatter for the
    127         * y-values).
    128         *
    129         * @param formatString  the item label format string (<code>null</code>
    130         *                      not permitted).
    131         * @param xFormat  the format object for the x values (<code>null</code>
    132         *                 permitted).
    133         * @param yFormat  the format object for the y values (<code>null</code>
    134         *                 not permitted).
    135         *
    136         * @since 1.0.4
    137         */
    138        public StandardXYItemLabelGenerator(String formatString,
    139                NumberFormat xFormat, DateFormat yFormat) {
    140
    141            super(formatString, xFormat, yFormat);
    142        }
    143
    144        /**
    145         * Creates a label generator using the specified date formatters.
    146         *
    147         * @param formatString  the label format string (<code>null</code> not
    148         *                      permitted).
    149         * @param xFormat  the format object for the x values (<code>null</code>
    150         *                 not permitted).
    151         * @param yFormat  the format object for the y values (<code>null</code>
    152         *                 not permitted).
    153         */
    154        public StandardXYItemLabelGenerator(String formatString,
    155                DateFormat xFormat, DateFormat yFormat) {
    156
    157            super(formatString, xFormat, yFormat);
    158        }
    159
    160        /**
    161         * Generates the item label text for an item in a dataset.
    162         *
    163         * @param dataset  the dataset (<code>null</code> not permitted).
    164         * @param series  the series index (zero-based).
    165         * @param item  the item index (zero-based).
    166         *
    167         * @return The label text (possibly <code>null</code>).
    168         */
    169        public String generateLabel(XYDataset dataset, int series, int item) {
    170            return generateLabelString(dataset, series, item);
    171        }
    172
    173        /**
    174         * Returns an independent copy of the generator.
    175         *
    176         * @return A clone.
    177         *
    178         * @throws CloneNotSupportedException if cloning is not supported.
    179         */
    180        public Object clone() throws CloneNotSupportedException {
    181            return super.clone();
    182        }
    183
    184        /**
    185         * Tests this object for equality with an arbitrary object.
    186         *
    187         * @param obj  the other object (<code>null</code> permitted).
    188         *
    189         * @return A boolean.
    190         */
    191        public boolean equals(Object obj) {
    192            if (obj == this) {
    193                return true;
    194            }
    195            if (!(obj instanceof StandardXYItemLabelGenerator)) {
    196                return false;
    197            }
    198            return super.equals(obj);
    199        }
    200
    201    }